"""Bug: Locking in xpcom call when using vboxapi in forked multiprocessing
process after making a call in the main parent process.
 
This bug occurs if you have used the manager to talk to VirtualBox in the main
process followed by trying to use the manager in a forked process.  

Looks like the vboxapi has some unrecoverable module global state? 

Python:  Python 2.7 64bit. 
Operating system: Ubuntu 12.04 x64
VirtualBox version: 4.2.18r88780
"""
import multiprocessing
import vboxapi

def listvms():
    pid = multiprocessing.current_process().pid
    print("Query from process %s" % pid) 
    manager = vboxapi.VirtualBoxManager(None, None)
    vbox = manager.getVirtualBox()
    l = "\n".join([" + " + m.name for m in vbox.getMachines()])
    print("In process %s:\n%s" % (pid, l))

def worker():
    listvms()

if __name__ == '__main__':
    # Note, if you comment out this listing function here, the subprocesses 
    #       will print out the listing without hanging. 
    listvms()
    p = [multiprocessing.Process(target=worker) for a in range(10)]
    [a.start() for a in p]
    [a.join() for a in p]


